VAR
   long Level_Cog, pin_cog, Cog, Stack[20]
      
PUB start(Level,Pin,Speed,Phase) : Pass 

    Stop
    Pass := (Cog := cognew(Auto(Level,Pin,Speed,Phase), @Stack) + 1)

PRI Auto(Level,Pin,Speed,Phase)   | x

  cognew(@entry, @Level_Cog)
    Level_Cog := Level
    pin_cog   := Pin

 If Level <> 0
  waitcnt(clkfreq/1000 * Phase + cnt)         ' Wait for Phase ms to start fadding
      Level_Cog := Level                          'a constant here locks to value x percent high
      waitcnt(clkfreq/80_000 * Speed + cnt)   'wait Speed 'ms' before next update
 else
  waitcnt(clkfreq/1000 * Phase + cnt)         ' Wait for Phase ms to start fadding
  repeat
    repeat x from 0 to period                 'linearly advance level_cog from 0 to 100
      Level_Cog := x                          'a constant here locks to value x percent high
      waitcnt(clkfreq/80_000 * Speed + cnt)   'wait Speed 'ms' before next update
    repeat x from period to 0                 'linearly advance level_cog from 100 to 0
      Level_Cog := x                          'a constant here locks to value x percent high
      waitcnt(clkfreq/80_000 * Speed + cnt)   'wait Speed 'ms' before next update
      
PUB Stop
'Stop the cog we started earlier, if any.
if Cog
cogstop(Cog~ - 1)

DAT
        org

entry
        rdlong  t3,par              ' Get Delay_Cog  ( IT IS NOT USED...ONLY FOR LEARN, HOW TO PASS ANOTHER VALUE TO THE ASM CODE )
        mov     t1,par              ' t1 holds the par address := Delay_Cog address
        add     t1,#4               ' Adding 4 tp Delay_Cog address get the pin_cog address
        rdlong  t2,t1               ' get pin number from pin_cog address
        mov     asm_pin,#1          ' assign 1 to variable
        shl     asm_pin,t2          ' shift the variable t2 times, and get the just dira
        mov     dira, asm_pin       ' set APIN to output

        movi ctra,#%00010000_0         'establish counter A mode and APIN  (CTRMODE := 00100) Passed like Propeller Manual suggest to use.
        movd ctra,#%00000000_0
        movs ctra,t2                   'APIN 
        mov frqa, #1                   'set counter to increment 1 each cycle

        mov time, cnt                  'record current time
        add time, period               'establish next period

:loop   rdlong value, par              'get an up to date pulse width
        waitcnt time, period           'wait until next period
        neg phsa, value                'back up phsa so that it
        jmp #:loop                     'loop for next cycle

period  long 100                       'full out in high                      
time    res 1
value   res 1
t1      res 1
t2      res 1
t3      res 1
asm_pin res 1